function [f,g_p,g_r,g_m,g_r_w,g_m_w,policy_pm,policy_prm,policy_pms,policy_prms,policy_rms,policy_ms,policy_rm,v_p,v_r,v_m] ...
    = flow_difference_1hh(x, sm, sm1, sm2, gamma,u_p,u_r,u_m,u_s,u_p_s,u_r_s,u_m_s,u_s_s,g_tran,g_tran_s,g_mat,y,y_s,h_m,h_m_s,k_p,k_r,k_m,num_y_s,num_y,num_r,max_w,y_low)

beta    = 0.95;      % discount factor
num_d = 3; % 1: public, 2: regulated, 3: market (mover + stayer);

% moving cost matrix
m_cost = gamma*ones(num_d,num_d);
for i=1:num_d
    m_cost(i,i) = 0;
end

% read input variables
x(1) = max(1,min(max_w,x(1)));        % restrict the w_bar be larger than 1 less than num_w
w_bar = floor(x(1));    
pw = 1-(x(1)-w_bar);
qr = x(2:num_r+1);
qr = min(1,max(0,qr));
num_w = w_bar+3;

% initialize arrays
% unconditional value functions
% coarse grids
v_r_s = zeros(num_y_s,num_w,num_r);
v_m_s = zeros(num_y_s,num_y_s,num_w);
% fine grids
v_r = zeros(num_y,num_w,num_r);
v_m = zeros(num_y,num_y,num_w);
% conditional value functions
% coarse grids
cv_p_s = zeros(num_y_s,num_d);
cv_m_s = zeros(num_y_s,num_w);
cv_s_s = zeros(num_y_s,num_y_s,num_w);
cv_r_s = zeros(num_y_s,num_d,num_w,num_r);
% fine grids
cv_p = zeros(num_y,num_d);
cv_m = zeros(num_y,num_w);
cv_s = zeros(num_y,num_y,num_w);
cv_r = zeros(num_y,num_d,num_w,num_r);
% densities
g_m_w = zeros(num_w,1);
g_m   = zeros(num_y,num_y,num_w);
g_r_w = zeros(num_w,num_r);
g_r   = zeros(num_y, num_w,num_r);
max_cv_r_m = zeros(num_y_s,num_d,num_r);
v_r_T = zeros(num_y_s,num_d,num_r);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 1. valufunction iteration
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% initial guess
u_max_s = max(max(max(u_p_s,u_m_s),u_r_s(:,1)),u_r_s(:,2));
v_p_s = u_max_s/(1-beta);
for i_h = 1:num_y_s
    v_m_s(:,i_h,1) = u_max_s/(1-beta);
end

for i_r = 1:num_r
    v_r_s(:,1,i_r) = u_max_s/(1-beta);
end

eligible = (y_s<=y_low);
ineligible = (y_s>y_low);
eligible_rep = repmat(eligible,1,num_y_s);
ineligible_rep = repmat(ineligible,1,num_y_s);

dist =1; % error
its  =0; % interation
dist_temp = zeros(3,1);
f = zeros(3,1);
while (dist > sm1) && (its < 200)
    
    v_m_old = v_m_s(:,:,1);
    v_p_old = v_p_s;
    v_r_old = v_r_s(:,1,:);
    
    % conditional value function : public housing (d=1)
    for i_d=1:num_d
        cv_p_s(:,i_d) = u_p_s - m_cost(1,i_d) + beta*g_tran_s*v_p_s;
    end    
    
    % conditional value function : regulated (d=2)
    for i_d= 1:num_d
        for i_r=1:num_r
            cv_r_s(:,i_d,1,i_r)=u_r_s(:,i_r)-m_cost(2,i_d)+beta*g_tran_s*v_r_s(:,1,i_r);
        end
    end
    % conditional value function : mover (d=3)
    for i_y=1:num_y_s
        cv_m_s(i_y,1)=u_m_s(i_y)-gamma+beta*g_tran_s(i_y,:)*v_m_s(:,i_y,1);
    end
    
    % conditional value function : stayer (d=4)
    cv_s_s(:,:,1)=u_s_s+beta*g_tran_s*v_m_s(:,:,1);

    for i_d=1:num_d
        for i_r=1:num_r
            max_cv_r_m(:,i_d,i_r) = max(cv_m_s(:,1),cv_r_s(:,i_d,1,i_r));
            v_r_T(:,i_d,i_r) =max(cv_p_s(:,i_d),max_cv_r_m(:,i_d,i_r));
        end
    end
    
    v_p_s   = (1-sum(qr))*max(cv_p_s(:,1),cv_m_s(:,1));
      
    for i_r = 1:num_r
          v_p_s = v_p_s + qr(i_r)*v_r_T(:,1,i_r);
    end    
      
    % update conditional value function : public housing (d=1)
    for i_d=1:num_d
        cv_p_s(:,i_d) = u_p_s - m_cost(1,i_d) + beta*g_tran_s*v_p_s;
    end
     
    for i_d=1:num_d
        for i_r=1:num_r
            v_r_T(:,i_d,i_r) =max(cv_p_s(:,i_d),max_cv_r_m(:,i_d,i_r));
        end
    end    
    
    % backward induction
    
    max_cv_m_s = max(repmat(cv_m_s(:,1),1,num_y_s),cv_s_s(:,:,1));
    
    max_cv_r_m_s = zeros(num_y_s,num_y_s,num_r);
    
    for i_r = 1:num_r
        max_cv_r_m_s(:,:,i_r) = max(max_cv_m_s,repmat(cv_r_s(:,3,1,i_r),1,num_y_s));
    end
    
    for i_w=w_bar+2:-1:1
       
        % conditional value function : regulated (d=2)
        for i_d= 1:num_d
            for i_r=1:num_r
                cv_r_s(:,i_d,i_w+1,i_r)=u_r_s(:,i_r)-m_cost(2,i_d)...
                    +beta*g_tran_s*v_r_s(:,i_w+1,i_r);
            end
        end

        % conditional value function : mover (d=3)
        temp = g_tran_s*v_m_s(:,:,i_w+1);        
        cv_m_s(:,i_w+1)=u_m_s-gamma+beta*diag(temp);
                  
        % conditional value function : stayer (d=4)
        cv_s_s(:,:,i_w+1)=u_s_s+beta*temp;              
         
        if i_w<w_bar+1
            for i_r = 1:num_r
                v_r_s(:,i_w,i_r) = eligible.*max(cv_m_s(:,i_w+1), cv_r_s(:,2,i_w+1,i_r))...
                                 + ineligible.*max_cv_r_m(:,2,i_r);  
            end

            temp = max(repmat(cv_m_s(:,i_w+1),1,num_y_s),cv_s_s(:,:,i_w+1));
            
            v_m_s(:,:,i_w) = eligible_rep.*(qr(1)*max(temp,repmat(cv_r_s(:,3,i_w+1,1),1,num_y_s)) ...
                           + qr(2)*max(temp,repmat(cv_r_s(:,3,i_w+1,2),1,num_y_s)) ...
                           + (1-sum(qr))*temp )...
                           + ineligible_rep.*(qr(1)*max_cv_r_m_s(:,:,1)...
                           + qr(2)*max_cv_r_m_s(:,:,2)+ (1-sum(qr))*max_cv_m_s); 
            
        elseif i_w==w_bar+1
            
            
            for i_r = 1:num_r
                v_r_s(:,i_w,i_r) = pw*eligible.*v_r_T(:,2,i_r)...
                       + (1-pw)*eligible.*max(cv_m_s(:,i_w+1), cv_r_s(:,2,i_w+1,i_r))...
                       + ineligible.*max_cv_r_m(:,2,i_r);
            end

            temp = max(repmat(cv_m_s(:,i_w+1),1,num_y_s),cv_s_s(:,:,i_w+1));
                    
                    
            v_m_s(:,:,i_w) = eligible_rep.*(qr(1)*pw*max(repmat(v_r_T(:,3,1),1,num_y_s),cv_s_s(:,:,1))...
                        + qr(1)*(1-pw)*max(temp,repmat(cv_r_s(:,3,i_w+1,1),1,num_y_s))...
                        + qr(2)*pw*max(repmat(v_r_T(:,3,2),1,num_y_s),cv_s_s(:,:,1))...
                        + qr(2)*(1-pw)*max(temp,repmat(cv_r_s(:,3,i_w+1,2),1,num_y_s))...
                        + (1-sum(qr))*pw*max(repmat(max(cv_m_s(:,1), cv_p_s(:,3)),1,num_y_s),cv_s_s(:,:,1))...
                        + (1-sum(qr))*(1-pw)*temp) ...
                        + ineligible_rep.*(qr(1)*max_cv_r_m_s(:,:,1)...
                        + qr(2)*max_cv_r_m_s(:,:,2)...
                        + (1-sum(qr))*max_cv_m_s(:,:));  
                    
                    
                    
           
        else % i_w=w_bar+2
            
            for i_r = 1:num_r
                v_r_s(:,i_w,i_r) = eligible.*v_r_T(:,2,i_r)...
                       + ineligible.*max_cv_r_m(:,2,i_r);
            end
             
                    
            v_m_s(:,:,i_w) = eligible_rep.*(qr(1)*max(repmat(v_r_T(:,3,1),1,num_y_s),cv_s_s(:,:,1))...
                + qr(2)*max(repmat(v_r_T(:,3,2),1,num_y_s),cv_s_s(:,:,1))...
                + (1-sum(qr))*max(repmat(max(cv_m_s(:,1), cv_p_s(:,3)),1,num_y_s),cv_s_s(:,:,1)))...
                + ineligible_rep.*(qr(1)*max_cv_r_m_s(:,:,1)...
                + qr(2)*max_cv_r_m_s(:,:,2)...
                + (1-sum(qr))*max_cv_m_s(:,:));  
                    
        end % if i_w
    end % for i_w

      
    % convergence criterion
    dist_temp(1) = max(abs(v_p_s-v_p_old))/max(abs(v_p_old));
    dist_temp(2) = max(max(abs(v_m_s(:,:,1) - v_m_old)))/max(max(abs(v_m_old)));
    dist_temp(3) = max(max(abs(v_r_s(:,1,:) - v_r_old)))/max(max(abs(v_r_old)));
    dist = max(dist_temp);
    
    its = its+1;

end
%toc
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2. Policy function
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%interpolation using fine grids
v_p = interp1(y_s,v_p_s,y);

[y_s_mesh, h_s_mesh] = meshgrid(y_s, h_m_s);
[y_mesh, h_mesh] = meshgrid(y, h_m);
for j=1:w_bar+2
    v_m(:,:,j) = interp2(y_s_mesh,h_s_mesh, v_m_s(:,:,j),y_mesh,h_mesh);
    for i_r = 1:num_r
        v_r(:,j,i_r) = interp1(y_s, v_r_s(:,j,i_r),y);
    end
end

% conditional value function : public housing (d=1)
for i_d=1:num_d
    cv_p(:,i_d) = u_p - m_cost(1,i_d) + beta*g_tran*v_p;
end


% conditional value function : regulated (d=2)
for i_w=1:w_bar+2
    for i_d = 1:num_d
        for i_r=1:num_r
            cv_r(:,i_d,i_w,i_r)=u_r(:,i_r) - m_cost(2,i_d)+beta*g_tran*v_r(:,i_w,i_r);
        end
    end % i_d

    % conditional value function : mover (d=3)
    for i_y=1:num_y
        cv_m(i_y,i_w)=u_m(i_y)-gamma+beta*g_tran(i_y,:)*v_m(:,i_y,i_w);
    end % i_y

    % conditional value function : stayer (d=4)
    cv_s(:,:,i_w)=u_s+beta*g_tran*v_m(:,:,i_w);
end % i_w

% choice between public(1) and move(3,w=0), d=1 by construction
policy_pm =  1 + 2*(cv_m(:,1)> cv_p(:,1));

% choice among public(1), regulated(2,w=0), move(3,w=0), d=1 or 2
policy_prm = zeros(num_y,num_d,num_r);
for i_d=1:num_d
    for i_r=1:num_r 
       policy_prm(:,i_d,i_r) = 1+ 1*(cv_r(:,i_d,1,i_r) > cv_p(:,i_d)).*(cv_r(:,i_d,1,i_r) >= cv_m(:,1))...
                         + 2*(cv_m(:,1) > cv_p(:,i_d)).*(cv_m(:,1) > cv_r(:,i_d,1,i_r));
    end
end % i_d

% choice among public(1), move(3,w=0), stay(4,w=0), d=3 by construction
policy_pms = zeros(num_y,num_y);
for i_h=1:num_y
    policy_pms(:,i_h) = 1 +2*(cv_m(:,1) > cv_p(:,3)).*(cv_m(:,1)>=cv_s(:,i_h,1))...
                          +3*(cv_s(:,i_h,1) > cv_p(:,3)).*(cv_s(:,i_h,1)>cv_m(:,1));
end

% choice among public(1), regulated(2,w=0), move(3,w=0), stay(4,w=0), d=3 by
% construction
policy_prms = zeros(num_y,num_y,num_r);
for i_h=1:num_y
    for i_r=1:num_r
        policy_prms(:,i_h,i_r) = 1+1*(cv_r(:,3,1,i_r) > cv_p(:,3)).*(cv_r(:,3,1,i_r) >= cv_m(:,1)).*(cv_r(:,3,1,i_r)>=cv_s(:,i_h,1))...
                        +2*(cv_m(:,1) > cv_p(:,3)).*(cv_m(:,1) > cv_r(:,3,1,i_r)).*(cv_m(:,1)>=cv_s(:,i_h,1))...
                        +3*(cv_s(:,i_h,1) > cv_p(:,3)).*(cv_s(:,i_h,1)> cv_r(:,3,1,i_r)).*(cv_s(:,i_h,1)>cv_m(:,1));
    end
end

% choice regulated(2,w=0), move(3), stay(4), d=3 by
% construction
policy_rms = zeros(num_y,num_y,w_bar+2,num_r);
for i_r=1:num_r
    for i_w=1:w_bar+2
        for i_h=1:num_y
            policy_rms(:,i_h,i_w,i_r) = 2+1*(cv_m(:,i_w) > cv_r(:,3,i_w,i_r)).*(cv_m(:,i_w)>=cv_s(:,i_h,i_w))...
                                     +2*(cv_s(:,i_h,i_w)> cv_r(:,3,i_w,i_r)).*(cv_s(:,i_h,i_w)>cv_m(:,i_w));
        end
    end
end

policy_h = eye(num_y);

% choice among move(3), stay(4), d=3 by construction
policy_ms = zeros(num_y,num_y,w_bar+2);
for i_w= 1:w_bar+2
    for i_h=1:num_y
        policy_ms(:,i_h,i_w) = 3 + 1*(cv_s(:,i_h,i_w)>cv_m(:,i_w));
    end
end

% choice between, regulated(2) and market(3)
policy_rm = zeros(num_y,num_d,w_bar+2,num_r);
for i_d = 1:num_d
    for i_w=1:w_bar+2
        for i_r=1:num_r
            policy_rm(:,i_d,i_w,i_r) = 2 + 1*(cv_m(:,i_w) > cv_r(:,i_d,i_w,i_r));
        end
    end
end

policy_pm_1 = (policy_pm == 1);
policy_pm_3 = (policy_pm == 3);

policy_prm_1 = (policy_prm == 1);
policy_prm_2 = (policy_prm == 2);
policy_prm_3 = (policy_prm == 3);

policy_pms_1 = (policy_pms == 1);
policy_pms_3 = (policy_pms == 3);
policy_pms_4 = (policy_pms == 4);

policy_prms_1 = (policy_prms == 1);
policy_prms_2 = (policy_prms == 2);
policy_prms_3 = (policy_prms == 3);
policy_prms_4 = (policy_prms == 4);

policy_rms_2 = (policy_rms == 2);
policy_rms_3 = (policy_rms == 3);
policy_rms_4 = (policy_rms == 4);

policy_ms_3 = (policy_ms == 3);
policy_ms_4 = (policy_ms == 4);

policy_rm_2 = (policy_rm == 2);
policy_rm_3 = (policy_rm == 3);

%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3. Calculte SS densities by forward interation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% initial guess
g_p = mean(g_mat,2);

for i_w=1:w_bar+2
    for ih=1:num_y
        g_m(:,ih,i_w)   = mean(g_mat,2)/double(num_y);
    end
    for i_r=1:num_r
        g_r(:,i_w,i_r)   = mean(g_mat,2);
    end
end

g_w = 1/(1+w_bar + 1 -pw);
g_r_w(1:w_bar+1,:) = g_w;
g_r_w(w_bar+2,:)   = g_w*(1-pw);
g_m_w(1:w_bar+1) = g_w;
g_m_w(w_bar+2)   = g_w*(1-pw);

eligible = (y<=y_low);
ineligible = (y>y_low);
eligible_rep = repmat(eligible,1,num_y);
ineligible_rep = repmat(ineligible,1,num_y);

dist = 1.0;
its = 0;
dist_v = zeros(5,1);
% start iteration
while dist > sm2 && its<500  
    
    % save starting value        
    g_p_old = g_p;
    g_m_old = g_m;
    g_r_old = g_r;
    g_m_w_old = g_m_w;
    g_r_w_old = g_r_w;
    
    % g_p ----------------------------------------------------------------       
              
    g_p = (k_p*(1-sum(qr))*policy_pm_1.*g_p) ... 
        + k_m*(1-sum(qr))*eligible.*sum(policy_pms_1.*(g_m_w(w_bar+1)*pw*g_m(:,:,w_bar+1) + g_m_w(w_bar+2)*g_m(:,:,w_bar+2)),2);

    for i_r = 1:num_r
    g_p = g_p + (k_p*qr(i_r)*policy_prm_1(:,1,i_r).*g_p) ... 
        + k_r(i_r)*eligible.*policy_prm_1(:,2,i_r).*(g_r_w(w_bar+1,i_r)*pw*g_r(:,w_bar+1,i_r)+g_r_w(w_bar+2,i_r)*g_r(:,w_bar+2,i_r))...
        + k_m*qr(i_r)*eligible.*sum(policy_prms_1(:,:,i_r).*(g_m_w(w_bar+1)*pw*g_m(:,:,w_bar+1) + g_m_w(w_bar+2)*g_m(:,:,w_bar+2)),2);
    end
    g_p = g_mat*g_p;

    a = max(sm,sum(g_p));
    g_p = g_p/a;
    
     % g_r(y,0)-------------------------------------------------------------   
     
    for i_r=1:num_r
        
        g_r(:,1,i_r) = k_p*qr(i_r)*policy_prm_2(:,1,i_r).*g_p...
                     + k_r(i_r)*eligible.*policy_prm_2(:,2,i_r).*(g_r_w(w_bar+1,i_r)*pw*g_r(:,w_bar+1,i_r)+g_r_w(w_bar+2,i_r)*g_r(:,w_bar+2,i_r))...
                     + k_m*qr(i_r)*eligible.*sum(policy_prms_2(:,:,i_r).*(g_m_w(w_bar+1)*pw*g_m(:,:,w_bar+1)+g_m_w(w_bar+2)*g_m(:,:,w_bar+2)),2);

        temp = zeros(num_y,1);    
        for i_w=1:w_bar+2
            temp = temp + k_r(i_r)*g_r_w(i_w,i_r)*policy_rm_2(:,2,1,i_r).*g_r_old(:,i_w,i_r)...
                        + k_m*g_m_w(i_w)*qr(i_r)*sum(policy_rms_2(:,:,1,i_r).*g_m(:,:,i_w),2);
        end % i_w
        g_r(:,1,i_r) = g_r(:,1,i_r)+ ineligible.*temp;

        g_r(:,1,i_r) = g_mat*g_r(:,1,i_r);

        a = max(sm,sum(g_r(:,1,i_r)));
        g_r(:,1,i_r) = g_r(:,1,i_r)/a;

        g_r_w(1,i_r) = a/k_r(i_r);
    
    end
    
                   
    % g_m(y,0) ------------------------------------------------------------
   
    % compute part not depend on h
    
    g_m_temp1 = k_p*(1-sum(qr))*policy_pm_3.*g_p ...
              + k_m*(1-sum(qr))*eligible.*sum(policy_pms_3.*(g_m_w(w_bar+1)*pw*g_m(:,:,w_bar+1)+g_m_w(w_bar+2)*g_m(:,:,w_bar+2)),2);
    
    for i_r=1:num_r
        g_m_temp1 = g_m_temp1 + ...
              + k_p*qr(i_r)*policy_prm_3(:,1,i_r).*g_p...
              + k_r(i_r)*eligible.*policy_prm_3(:,2,i_r).*(g_r_w(w_bar+1,i_r)*pw*g_r(:,w_bar+1,i_r)+g_r_w(w_bar+2,i_r)*g_r(:,w_bar+2,i_r))...
              + k_m*qr(i_r)*eligible.*sum(policy_prms_3(:,:,i_r).*(g_m_w(w_bar+1)*pw*g_m(:,:,w_bar+1)+g_m_w(w_bar+2)*g_m(:,:,w_bar+2)),2);
    end
                  
    
    g_m(:,:,1) =  repmat(g_m_temp1,1,num_y).*policy_h...
                + k_m*(1-sum(qr))*eligible_rep.*policy_pms_4.*(g_m_w(w_bar+1)*pw*g_m(:,:,w_bar+1)+g_m_w(w_bar+2)*g_m(:,:,w_bar+2));
            
    for i_r=1:num_r
        g_m(:,:,1) = g_m(:,:,1) ...
        + k_m*qr(i_r)*eligible_rep.*policy_prms_4(:,:,i_r).*(g_m_w(w_bar+1)*pw*g_m(:,:,w_bar+1)+g_m_w(w_bar+2)*g_m(:,:,w_bar+2));
    end
     
    % compute part not depend on w
    temp = zeros(num_y,num_y);  
    temp1 = ((1-sum(qr))*policy_ms_3(:,:,1) + qr(1)*policy_rms_3(:,:,1,1) + qr(2)*policy_rms_3(:,:,1,2));
    temp2 = ((1-sum(qr))*policy_ms_4(:,:,1) + qr(1)*policy_rms_4(:,:,1,1) + qr(2)*policy_rms_4(:,:,1,2));
    for i_w=1:w_bar+2
        g_m_temp2 = k_m*g_m_w(i_w)*sum(temp1.*g_m_old(:,:,i_w),2) ;
         
        for i_r=1:num_r
            g_m_temp2 = g_m_temp2...
                + k_r(i_r)*g_r_w(i_w,i_r)*policy_rm_3(:,2,1,i_r).*g_r(:,i_w,i_r);
        end
        
        temp = temp + repmat(g_m_temp2,1,num_y).*policy_h ...
                    + k_m*g_m_w(i_w)*temp2.*g_m_old(:,:,i_w);
    end  % i_w

    g_m(:,:,1) = g_m(:,:,1) + ineligible_rep.*temp;

    g_m(:,:,1) = g_mat*g_m(:,:,1);   

   
    a = max(sm, sum(sum(g_m(:,:,1))));
    g_m(:,:,1) = g_m(:,:,1)/a;
    g_m_w(1) = a/k_m;
    
    % w=1,2,...,w_bar+1 ---------------------------------------------------
   
   for  i_w=2:w_bar+2
       
       for i_r=1:num_r
       
           % g_r
            g_r(:,i_w,i_r) =  k_r(i_r)*g_r_w(i_w-1,i_r)*policy_rm_2(:,2,i_w,i_r).*g_r(:,i_w-1,i_r)...
                       +  k_m*g_m_w(i_w-1)*qr(i_r)*sum(policy_rms_2(:,:,i_w,i_r).*g_m(:,:,i_w-1),2);

            g_r(:,i_w,i_r) = g_r(:,i_w,i_r).*eligible;  

            g_r(:,i_w,i_r) = g_mat*g_r(:,i_w,i_r);

            a = max(sm,sum(g_r(:,i_w,i_r)));
            g_r(:,i_w,i_r) = g_r(:,i_w,i_r)/a;

            g_r_w(i_w,i_r) = a/k_r(i_r);

            if i_w==w_bar+2
                g_r_w(i_w,i_r)= g_r_w(i_w,i_r)*(1-pw);
            end
        
       end % i_r

       % g_m
       % compute part not depend on h
       g_m_temp3 = k_m*g_m_w(i_w-1)*sum((1-sum(qr))*policy_ms_3(:,:,i_w).*g_m(:,:,i_w-1),2);
       
       for i_r = 1:num_r
           g_m_temp3    =  g_m_temp3 ...
                    +  k_r(i_r)*g_r_w(i_w-1,i_r)*policy_rm_3(:,2,i_w,i_r).*g_r(:,i_w-1,i_r)...
                    +  k_m*g_m_w(i_w-1)*sum(qr(i_r)*policy_rms_3(:,:,i_w,i_r).*g_m(:,:,i_w-1),2);
       end

       g_m(:,:,i_w) = repmat(g_m_temp3,[1 num_y]).*policy_h ...
                   +  k_m*g_m_w(i_w-1)*(1-sum(qr))*policy_ms_4(:,:,i_w).*g_m(:,:,i_w-1);
       for i_r = 1:num_r
           g_m(:,:,i_w) = g_m(:,:,i_w) ...
               +  k_m*g_m_w(i_w-1)*qr(i_r)*policy_rms_4(:,:,i_w,i_r).*g_m(:,:,i_w-1);
       end

       g_m(:,:,i_w) = g_m(:,:,i_w).*eligible_rep; 

       g_m(:,:,i_w) = g_mat*g_m(:,:,i_w);

       a = max(sm,sum(sum(g_m(:,:,i_w))));
       
       g_m(:,:,i_w) = g_m(:,:,i_w)/a;

       g_m_w(i_w) = a/k_m;

       if i_w==w_bar+2
            g_m_w(i_w)= g_m_w(i_w)*(1-pw);
       end      
    
   end
    
    for i_r=1:num_r
        a = sum(g_r_w(1:w_bar+2,i_r));
        g_r_w(1:w_bar+2,i_r) = g_r_w(1:w_bar+2,i_r)/a;
    end
    
    a = sum(g_m_w(1:w_bar+2));
    g_m_w = g_m_w/a;
    
    % distance and update     

    dist_v(1) = max(abs(g_p_old - g_p))/max(abs(g_p_old ));
    dist_v(2) = max(max(max(abs(g_m_old(:,:,1:w_bar+2) - g_m(:,:,1:w_bar+2)))))/max(max(max(abs(g_m_old(:,:,1:w_bar+2)))));
    dist_v(3) = max(max(max(abs(g_r_old(:,1:w_bar+2,:) - g_r(:,1:w_bar+2,:)))))/max(max(max(abs(g_r_old(:,1:w_bar+2,:)))));
    dist_v(4) = max(abs(g_m_w_old(1:w_bar+2) - g_m_w(1:w_bar+2)))/max(abs(g_m_w_old(1:w_bar+2)));
    dist_v(5) = max(max(abs(g_r_w_old(1:w_bar+2,:) - g_r_w(1:w_bar+2,:))))/max(max(abs(g_r_w_old(1:w_bar+2,:)))); 
   
    dist = max(dist_v);       
  
    its = its +1;
    %disp(dist)
end 
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 4. Calcualte inflow and outflow
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% puclic housing
outflow = sum(k_p*(1-sum(qr))*policy_pm_3.*g_p);
    
for i_r=1:num_r
    outflow = outflow + sum(k_p*qr(i_r)*((policy_prm(:,1,i_r)> 1).*g_p));       
end      
       
inflow =    sum(eligible.*(k_m*(1-sum(qr))*sum(policy_pms_1.*(g_m_w(w_bar+1)*pw*g_m(:,:,w_bar+1)...
                                                            +g_m_w(w_bar+2)*g_m(:,:,w_bar+2)),2)));

for i_r=1:num_r
    inflow = inflow + sum(eligible.*(k_m*qr(i_r)*sum(policy_prms_1(:,:,i_r).*(g_m_w(w_bar+1)*pw*g_m(:,:,w_bar+1)+g_m_w(w_bar+2)*g_m(:,:,w_bar+2)),2)...
                    + k_r(i_r)*policy_prm_1(:,2,i_r).*(g_r_w(w_bar+1,i_r)*pw*g_r(:,w_bar+1,i_r) + g_r_w(w_bar+2,i_r)*g_r(:,w_bar+2,i_r))));
end
        
% regulated housing -------------------------------------------------------       
of_r = zeros(num_r,1);
if_r = zeros(num_r,1);

for i_r=1:num_r
    % (1) with offer to public housing

    of_r(i_r) = sum(k_r(i_r)*eligible.*(policy_prm(:,2,i_r)~=2).*(pw*g_r_w(w_bar+1,i_r)*g_r(:,w_bar+1,i_r)...
                                                                    +g_r_w(w_bar+2,i_r)*g_r(:,w_bar+2,i_r)));

    if_r(i_r) = sum(k_p*qr(i_r)*policy_prm_2(:,1,i_r).*g_p...
              + k_m*qr(i_r)*eligible.*sum(policy_prms_2(:,:,i_r).*(pw*g_m_w(w_bar+1)*g_m(:,:,w_bar+1)+g_m_w(w_bar+2)*g_m(:,:,w_bar+2)),2));


    % (2) without the offer to the public housing
    for i_w=1:w_bar+1 % 0,...,w_bar

        if i_w==w_bar+1
             px = pw;
        else
             px = 0;
        end

         of_r(i_r) = of_r(i_r) +  (1-px)*k_r(i_r)*g_r_w(i_w,i_r)*sum(eligible.*policy_rm_3(:,2,i_w+1,i_r).*g_r(:,i_w,i_r));
         if_r(i_r) = if_r(i_r) +  (1-px)*k_m*qr(i_r)*g_m_w(i_w)*sum(eligible.*sum(policy_rms_2(:,:,i_w+1,i_r).*g_m(:,:,i_w),2)); 

    end

     % (3) ineligible

    for i_w=1:w_bar+2 % 0,...,w_bar+1
             of_r(i_r) = of_r(i_r) + k_r(i_r)*g_r_w(i_w,i_r)*sum(ineligible.*policy_rm_3(:,2,1,i_r).*g_r(:,i_w,i_r));
             if_r(i_r) = if_r(i_r) + k_m*qr(i_r)*g_m_w(i_w)*sum(ineligible.*sum(policy_rms_2(:,:,1,i_r).*g_m(:,:,i_w),2));
    end
end
%--------------------------------------------------------------------------

    f(1,1) = inflow - outflow;
    f(2:1+num_r,1) = if_r - of_r;

