function [f,g_p,g_r,g_m,g_r_w,g_m_w,policy_pm,policy_prm,policy_pms,policy_prms,policy_rms,policy_ms,policy_rm,...
    vv_p,vv_r,vv_m,k_p,k_r,k_m]= flow_difference_2hh(xx,sm2,sm,sm1,num_y,num_r,n_type,max_w,k_p_0,k_r_0,k_m_0,...
    g_mat,g_all,y,y_low,alpha,h,h_r,p_r,k_pmr,k_rr,k_mm,num_y_s, g_all_s, y_s,gamma,h_min,p_m)

tau     = 0.3;       % tax rate in public housing
beta = 0.95;
% define vectors
dist_v = zeros(8,n_type);  
p_temp = zeros(n_type,1);
k_temp = zeros(n_type,num_r);
m_temp = zeros(n_type,1);
g_w = zeros(n_type,1);
inflow = zeros(n_type,1);
outflow = zeros(n_type,1);
if_r = zeros(n_type,num_r);
of_r = zeros(n_type,num_r);
% read input variables
xx(1) = min(max_w,max(1,xx(1)));
w_bar = floor(xx(1));
pw = 1-(xx(1)-w_bar);
qr = xx(2:num_r+1);
qr = min(1,max(0,qr));
num_w = w_bar+3;

num_d = 3; % 1: public, 2: regulated, 3: market (mover + stayer);

% initialize arrays
% unconditional value functions
% coarse grids
v_r_s = zeros(num_y_s,num_w,num_r);
v_m_s = zeros(num_y_s,num_y_s,num_w);
% fine grids
v_r = zeros(num_y,num_w,num_r);
v_m = zeros(num_y,num_y,num_w);

max_cv_r_m = zeros(num_y_s,num_d,num_r);
v_r_T = zeros(num_y_s,num_d,num_r);

vv_p = zeros(num_y,n_type);
vv_m = zeros(num_y,num_y,num_w,n_type);
vv_r = zeros(num_y,num_w,n_type,num_r);
% conditional value functions
% coarse grids
cv_p_s = zeros(num_y_s,num_d);
cv_m_s = zeros(num_y_s,num_w);
cv_s_s = zeros(num_y_s,num_y_s,num_w);
cv_r_s = zeros(num_y_s,num_d,num_w,num_r);
% fine grids
cv_p = zeros(num_y,num_d);
cv_m = zeros(num_y,num_w);
cv_s = zeros(num_y,num_y,num_w);
cv_r = zeros(num_y,num_d,num_w,num_r);
% densities
g_p   = zeros(num_y, n_type);
g_m_w = zeros(num_w,n_type);
g_m   = zeros(num_y,num_y,num_w,n_type);
g_r_w = zeros(num_w,n_type,num_r);
g_r   = zeros(num_y, num_w,n_type,num_r);

policy_pm = zeros(num_y,n_type);
policy_prm = zeros(num_y,num_d,n_type,num_r);
policy_pms = zeros(num_y,num_y,n_type);
policy_prms = zeros(num_y,num_y,n_type,num_r);
policy_rms = zeros(num_y,num_y,w_bar+2,n_type,num_r);
policy_ms = zeros(num_y,num_y,w_bar+2,n_type);
policy_rm = zeros(num_y,num_d,w_bar+2,n_type,num_r);
%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 1. valufunction iteration
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% initial guess
p_w = zeros(num_w,n_type);
for j=1:n_type
    
    p_w(w_bar+2,j) = 1;
    p_w(w_bar+1,j) = pw;

    g_tran = g_all(:,:,j);
    g_tran_s = g_all_s(:,:,j); 
    
    m_cost = gamma(j)*ones(num_d,num_d);
    for i=1:num_d
        m_cost(i,i) = 0;
    end


    % define flow utility function
    u_p_s = ((1-tau)*y_s(:,j)).^(1-alpha(j)).*(h(j)-h_min(j)).^alpha(j);            % public
    u_r_s = zeros(num_y_s,num_r);                                            % regulated
    u_m_s = alpha(j)^alpha(j)*(1-alpha(j))^(1-alpha(j))*(y_s(:,j)-h_min(j)*p_m)/p_m^alpha(j); % mover
    h_m_s = alpha(j)*(y_s(:,j)-h_min(j)*p_m)/p_m+h_min(j);                           % optimal housing consumption for movers with each income
    u_s_s = zeros(num_y_s,num_y_s);                                      % stayer

    for i_y=1:num_y_s
        for i_h=1:num_y_s
            if y_s(i_y,j)-p_m*h_m_s(i_h) < sm
                u_s_s(i_y,i_h) = -1000000000;
            else
                u_s_s(i_y,i_h) = (y_s(i_y,j)-p_m*h_m_s(i_h))^(1-alpha(j))*(h_m_s(i_h)-h_min(j))^alpha(j);
            end
        end
    end

    for i_r=1:num_r
        for i_y=1:num_y_s
            if y_s(i_y,j)-p_r(i_r)*h_r(j,i_r) < sm
                u_r_s(i_y,i_r) = -1000000000;
            else
                u_r_s(i_y,i_r) = (y_s(i_y,j)-p_r(i_r)*h_r(j,i_r))^(1-alpha(j))*(h_r(j,i_r)-h_min(j))^alpha(j);
            end
        end
    end

    u_max_s = max(max(max(u_p_s,u_m_s),u_r_s(:,1)),u_r_s(:,2));
    v_p_s = u_max_s/(1-beta);
    for i_h = 1:num_y_s
        v_m_s(:,i_h,1) = u_max_s/(1-beta);
    end

    for i_r = 1:num_r
        v_r_s(:,1,i_r) = u_max_s/(1-beta);
    end

    eligible = (y_s(:,j)<=y_low(j));
    ineligible = (y_s(:,j)>y_low(j));
    eligible_rep = repmat(eligible,1,num_y_s);
    ineligible_rep = repmat(ineligible,1,num_y_s);

    dist =1; % error
    its  =0; % interation
    dist_temp = zeros(3,1);
    f = zeros(3,1);
    while (dist > sm1) && (its < 200)

        v_m_old = v_m_s(:,:,1);
        v_p_old = v_p_s;
        v_r_old = v_r_s(:,1,:);

        % conditional value function : public housing (d=1)
        for i_d=1:num_d
            cv_p_s(:,i_d) = u_p_s - m_cost(1,i_d) + beta*g_tran_s*v_p_s;
        end    

        % conditional value function : regulated (d=2)
        for i_d= 1:num_d
            for i_r=1:num_r
                cv_r_s(:,i_d,1,i_r)=u_r_s(:,i_r)-m_cost(2,i_d)+beta*g_tran_s*v_r_s(:,1,i_r);
            end
        end
        % conditional value function : mover (d=3)
        for i_y=1:num_y_s
            cv_m_s(i_y,1)=u_m_s(i_y)-gamma(j)+beta*g_tran_s(i_y,:)*v_m_s(:,i_y,1);
        end

        % conditional value function : stayer (d=4)
        cv_s_s(:,:,1)=u_s_s+beta*g_tran_s*v_m_s(:,:,1);

        for i_d=1:num_d
            for i_r=1:num_r
                max_cv_r_m(:,i_d,i_r) = max(cv_m_s(:,1),cv_r_s(:,i_d,1,i_r));
                v_r_T(:,i_d,i_r) =max(cv_p_s(:,i_d),max_cv_r_m(:,i_d,i_r));
            end
        end



        v_p_s   = (1-sum(qr))*max(cv_p_s(:,1),cv_m_s(:,1));

        for i_r = 1:num_r
              v_p_s = v_p_s + qr(i_r)*v_r_T(:,1,i_r);
        end    

        % update conditional value function : public housing (d=1)
        for i_d=1:num_d
            cv_p_s(:,i_d) = u_p_s - m_cost(1,i_d) + beta*g_tran_s*v_p_s;
        end

        for i_d=1:num_d
            for i_r=1:num_r
                max_cv_r_m(:,i_d,i_r) = max(cv_m_s(:,1),cv_r_s(:,i_d,1,i_r));
                v_r_T(:,i_d,i_r) =max(cv_p_s(:,i_d),max_cv_r_m(:,i_d,i_r));
            end
        end    

        % backward induction

        max_cv_m_s = max(repmat(cv_m_s(:,1),1,num_y_s),cv_s_s(:,:,1));

        max_cv_r_m_s = zeros(num_y_s,num_y_s,num_r);

        for i_r = 1:num_r
            max_cv_r_m_s(:,:,i_r) = max(max_cv_m_s,repmat(cv_r_s(:,3,1,i_r),1,num_y_s));
        end

        for i_w=w_bar+2:-1:1

            % conditional value function : regulated (d=2)
            for i_d= 1:num_d
                for i_r=1:num_r
                    cv_r_s(:,i_d,i_w+1,i_r)=u_r_s(:,i_r)-m_cost(2,i_d)...
                        +beta*g_tran_s*v_r_s(:,i_w+1,i_r);
                end
            end

            % conditional value function : mover (d=3)
            temp = g_tran_s*v_m_s(:,:,i_w+1);        
            cv_m_s(:,i_w+1)=u_m_s-gamma(j)+beta*diag(temp);

            % conditional value function : stayer (d=4)
            cv_s_s(:,:,i_w+1)=u_s_s+beta*temp;              

            if i_w<w_bar+1
                for i_r = 1:num_r
                    v_r_s(:,i_w,i_r) = eligible.*max(cv_m_s(:,i_w+1), cv_r_s(:,2,i_w+1,i_r))...
                                     + ineligible.*max_cv_r_m(:,2,i_r);  
                end

                temp = max(repmat(cv_m_s(:,i_w+1),1,num_y_s),cv_s_s(:,:,i_w+1));

                v_m_s(:,:,i_w) = eligible_rep.*(qr(1)*max(temp,repmat(cv_r_s(:,3,i_w+1,1),1,num_y_s)) ...
                               + qr(2)*max(temp,repmat(cv_r_s(:,3,i_w+1,2),1,num_y_s)) ...
                               + (1-sum(qr))*temp )...
                               + ineligible_rep.*(qr(1)*max_cv_r_m_s(:,:,1)...
                               + qr(2)*max_cv_r_m_s(:,:,2)+ (1-sum(qr))*max_cv_m_s); 

            elseif i_w==w_bar+1


                for i_r = 1:num_r
                    v_r_s(:,i_w,i_r) = pw*eligible.*v_r_T(:,2,i_r)...
                           + (1-pw)*eligible.*max(cv_m_s(:,i_w+1), cv_r_s(:,2,i_w+1,i_r))...
                           + ineligible.*max_cv_r_m(:,2,i_r);
                end

                temp = max(repmat(cv_m_s(:,i_w+1),1,num_y_s),cv_s_s(:,:,i_w+1));                        
                                    
                v_m_s(:,:,i_w) = eligible_rep.*(qr(1)*pw*max(repmat(v_r_T(:,3,1),1,num_y_s),cv_s_s(:,:,1))...
                        + qr(1)*(1-pw)*max(temp,repmat(cv_r_s(:,3,i_w+1,1),1,num_y_s))...
                        + qr(2)*pw*max(repmat(v_r_T(:,3,2),1,num_y_s),cv_s_s(:,:,1))...
                        + qr(2)*(1-pw)*max(temp,repmat(cv_r_s(:,3,i_w+1,2),1,num_y_s))...
                        + (1-sum(qr))*pw*max(repmat(max(cv_m_s(:,1), cv_p_s(:,3)),1,num_y_s),cv_s_s(:,:,1))...
                        + (1-sum(qr))*(1-pw)*temp) ...
                        + ineligible_rep.*(qr(1)*max_cv_r_m_s(:,:,1)...
                        + qr(2)*max_cv_r_m_s(:,:,2)...
                        + (1-sum(qr))*max_cv_m_s(:,:));  

            else % i_w=w_bar+2

                for i_r = 1:num_r
                    v_r_s(:,i_w,i_r) = eligible.*v_r_T(:,2,i_r)...
                           + ineligible.*max_cv_r_m(:,2,i_r);
                end               
                        
                v_m_s(:,:,i_w) = eligible_rep.*(qr(1)*max(repmat(v_r_T(:,3,1),1,num_y_s),cv_s_s(:,:,1))...
                        + qr(2)*max(repmat(v_r_T(:,3,2),1,num_y_s),cv_s_s(:,:,1))...
                        + (1-sum(qr))*max(repmat(max(cv_m_s(:,1), cv_p_s(:,3)),1,num_y_s),cv_s_s(:,:,1)))...
                        + ineligible_rep.*(qr(1)*max_cv_r_m_s(:,:,1)...
                        + qr(2)*max_cv_r_m_s(:,:,2)...
                        + (1-sum(qr))*max_cv_m_s(:,:));  
            end % if i_w
        end % for i_w

        % convergence criterion
        dist_temp(1) = max(abs(v_p_s-v_p_old))/max(abs(v_p_old));
        dist_temp(2) = max(max(abs(v_m_s(:,:,1) - v_m_old)))/max(max(abs(v_m_old)));
        dist_temp(3) = max(max(abs(v_r_s(:,1,:) - v_r_old)))/max(max(abs(v_r_old)));
        dist = max(dist_temp);

        its = its+1;

    end

    %% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % 2. Policy function
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     % define flow utility function
    u_p = ((1-tau)*y(:,j)).^(1-alpha(j)).*(h(j)-h_min(j)).^alpha(j);            % public
    u_r = zeros(num_y,num_r);                                            % regulated
    u_m = alpha(j)^alpha(j)*(1-alpha(j))^(1-alpha(j))*(y(:,j)-h_min(j)*p_m)/p_m^alpha(j); % mover
    h_m = alpha(j)*(y(:,j)-h_min(j)*p_m)/p_m+h_min(j);                           % optimal housing consumption for movers with each income
    u_s = zeros(num_y,num_y);                                      % stayer

    for i_y=1:num_y
        for i_h=1:num_y
            if y(i_y,j)-p_m*h_m(i_h) < sm
                u_s(i_y,i_h) = -1000000000;
            else
                u_s(i_y,i_h) = (y(i_y,j)-p_m*h_m(i_h))^(1-alpha(j))*(h_m(i_h)-h_min(j))^alpha(j);
            end
        end
    end

    for i_r=1:num_r
        for i_y=1:num_y
            if y(i_y,j)-p_r(i_r)*h_r(j,i_r) < sm
                u_r(i_y,i_r) = -1000000000;
            else
                u_r(i_y,i_r) = (y(i_y,j)-p_r(i_r)*h_r(j,i_r))^(1-alpha(j))*(h_r(j,i_r)-h_min(j))^alpha(j);
            end
        end
    end
    
    v_p = interp1(y_s(:,j),v_p_s,y(:,j));

    [y_s_mesh, h_s_mesh] = meshgrid(y_s(:,j), h_m_s);
    [y_mesh, h_mesh] = meshgrid(y(:,j), h_m);
    for i_w=1:w_bar+2
        v_m(:,:,i_w) = interp2(y_s_mesh,h_s_mesh, v_m_s(:,:,i_w),y_mesh,h_mesh);
        for i_r = 1:num_r
            v_r(:,i_w,i_r) = interp1(y_s(:,j), v_r_s(:,i_w,i_r),y(:,j));
        end
    end
       
    % conditional value function : public housing (d=1)
    for i_d=1:num_d
        cv_p(:,i_d) = u_p - m_cost(1,i_d) + beta*g_tran*v_p;
    end

    % conditional value function : regulated (d=2)
    for i_w=1:w_bar+2
        for i_d = 1:num_d
            for i_r=1:num_r
                cv_r(:,i_d,i_w,i_r)=u_r(:,i_r) - m_cost(2,i_d)+beta*g_tran*v_r(:,i_w,i_r);
            end
        end % i_d

        % conditional value function : mover (d=3)
        for i_y=1:num_y
            cv_m(i_y,i_w)=u_m(i_y)-gamma(j)+beta*g_tran(i_y,:)*v_m(:,i_y,i_w);
        end % i_y

        % conditional value function : stayer (d=4)
        cv_s(:,:,i_w)=u_s+beta*g_tran*v_m(:,:,i_w);
    end % i_w

    % choice between public(1) and move(3,w=0), d=1 by construction
    policy_pm(:,j) =  1 + 2*(cv_m(:,1)> cv_p(:,1));

    % choice among public(1), regulated(2,w=0), move(3,w=0), d=1 or 2

    for i_d=1:num_d
        for i_r=1:num_r 
           policy_prm(:,i_d,j,i_r) = 1+ 1*(cv_r(:,i_d,1,i_r) > cv_p(:,i_d)).*(cv_r(:,i_d,1,i_r) >= cv_m(:,1))...
                             + 2*(cv_m(:,1) > cv_p(:,i_d)).*(cv_m(:,1) > cv_r(:,i_d,1,i_r));
        end
    end % i_d

    % choice among public(1), move(3,w=0), stay(4,w=0), d=3 by construction
    
    for i_h=1:num_y
        policy_pms(:,i_h,j) = 1 +2*(cv_m(:,1) > cv_p(:,3)).*(cv_m(:,1)>=cv_s(:,i_h,1))...
                              +3*(cv_s(:,i_h,1) > cv_p(:,3)).*(cv_s(:,i_h,1)>cv_m(:,1));
    end

    % choice among public(1), regulated(2,w=0), move(3,w=0), stay(4,w=0), d=3 by
    % construction
    
    for i_h=1:num_y
        for i_r=1:num_r
            policy_prms(:,i_h,j,i_r) = 1+1*(cv_r(:,3,1,i_r) > cv_p(:,3)).*(cv_r(:,3,1,i_r) >= cv_m(:,1)).*(cv_r(:,3,1,i_r)>=cv_s(:,i_h,1))...
                            +2*(cv_m(:,1) > cv_p(:,3)).*(cv_m(:,1) > cv_r(:,3,1,i_r)).*(cv_m(:,1)>=cv_s(:,i_h,1))...
                            +3*(cv_s(:,i_h,1) > cv_p(:,3)).*(cv_s(:,i_h,1)> cv_r(:,3,1,i_r)).*(cv_s(:,i_h,1)>cv_m(:,1));
        end
    end

    % choice regulated(2,w=0), move(3), stay(4), d=3 by
    % construction
    
    for i_r=1:num_r
        for i_w=1:w_bar+2
            for i_h=1:num_y
                policy_rms(:,i_h,i_w,j,i_r) = 2+1*(cv_m(:,i_w) > cv_r(:,3,i_w,i_r)).*(cv_m(:,i_w)>=cv_s(:,i_h,i_w))...
                                         +2*(cv_s(:,i_h,i_w)> cv_r(:,3,i_w,i_r)).*(cv_s(:,i_h,i_w)>cv_m(:,i_w));
            end
        end
    end

    policy_h = eye(num_y);

    % choice among move(3), stay(4), d=3 by construction
    
    for i_w= 1:w_bar+2
        for i_h=1:num_y
            policy_ms(:,i_h,i_w,j) = 3 + 1*(cv_s(:,i_h,i_w)>cv_m(:,i_w));
        end
    end

    % choice between, regulated(2) and market(3)

    for i_d = 1:num_d
        for i_w=1:w_bar+2
            for i_r=1:num_r
                policy_rm(:,i_d,i_w,j,i_r) = 2 + 1*(cv_m(:,i_w) > cv_r(:,i_d,i_w,i_r));
            end
        end
    end
    
    vv_p(:,j)   = v_p;
    vv_r(:,:,j,:) = v_r(:,:,:);
    vv_m(:,:,:,j) = v_m;

end % j

policy_pm_1 = (policy_pm == 1);
policy_pm_3 = (policy_pm == 3);

policy_prm_1 = (policy_prm == 1);
policy_prm_2 = (policy_prm == 2);
policy_prm_3 = (policy_prm == 3);

policy_pms_1 = (policy_pms == 1);
policy_pms_3 = (policy_pms == 3);
policy_pms_4 = (policy_pms == 4);

policy_prms_1 = (policy_prms == 1);
policy_prms_2 = (policy_prms == 2);
policy_prms_3 = (policy_prms == 3);
policy_prms_4 = (policy_prms == 4);

policy_rms_2 = (policy_rms == 2);
policy_rms_3 = (policy_rms == 3);
policy_rms_4 = (policy_rms == 4);

policy_ms_3 = (policy_ms == 3);
policy_ms_4 = (policy_ms == 4);

policy_rm_2 = (policy_rm == 2);
policy_rm_3 = (policy_rm == 3);



%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3. Calculte SS densities by forward interation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% initial guess
k_p = k_p_0;
k_r = k_r_0;
k_m = k_m_0;

for j=1:n_type
    
    g_w(j) = 1/(1+w_bar + 1 -pw);
    g_p(:,j)     = mean(g_mat(:,:,j),2);

    for i_w=1:w_bar+2
        for ih=1:num_y
            g_m(:,ih,i_w,j)   = mean(g_mat(:,:,j),2)/(double(num_y));
        end
        for i_r=1:num_r
            g_r(:,i_w,j,i_r)   = mean(g_mat(:,:,j),2);
        end
    end

    g_r_w(1:w_bar+1,j,:) = g_w(j);
    g_r_w(w_bar+2,j,:)   = g_w(j)*(1-pw);
    g_m_w(1:w_bar+1,j) = g_w(j);
    g_m_w(w_bar+2,j)   = g_w(j)*(1-pw);
end % j

eligible = zeros(num_y,n_type);
ineligible = zeros(num_y,n_type);
eligible_rep = zeros(num_y,num_y,n_type);
ineligible_rep = zeros(num_y,num_y,n_type);

for j=1:n_type
    eligible(:,j) = (y(:,j)<=y_low(j));
    ineligible(:,j) = (y(:,j)>y_low(j));    
    eligible_rep(:,:,j) = repmat(eligible(:,j),1,num_y);
    ineligible_rep(:,:,j) = repmat(ineligible(:,j),1,num_y);
end

dist = 1.0;
its = 0;
% start iteration
g_mat_1 =g_mat(:,:,1);
g_mat_2 =g_mat(:,:,2);
while dist > sm2 && its<500  
    
    % save starting value        
    g_p_old = g_p;
    g_m_old = g_m;
    g_r_old = g_r;
    g_m_w_old = g_m_w;
    g_r_w_old = g_r_w;
    k_r_old = k_r;
    k_p_old = k_p;
    k_m_old = k_m;    
    
    for j=1:n_type
        
        k_temp(j,:) = 0; 
        m_temp(j) = 0;

        % g_p ----------------------------------------------------------------       

        g_p(:,j) = (k_p(j)*(1-sum(qr))*policy_pm_1(:,j).*g_p(:,j)) ... 
            + k_m(j)*(1-sum(qr))*eligible(:,j).*sum(policy_pms_1(:,:,j).*(g_m_w(w_bar+1,j)*pw*g_m(:,:,w_bar+1,j) + g_m_w(w_bar+2,j)*g_m(:,:,w_bar+2,j)),2);

        for i_r = 1:num_r
        g_p(:,j) = g_p(:,j) + (k_p(j)*qr(i_r)*policy_prm_1(:,1,j,i_r).*g_p(:,j)) ... 
            + k_r(j,i_r)*eligible(:,j).*policy_prm_1(:,2,j,i_r).*(g_r_w(w_bar+1,j,i_r)*pw*g_r(:,w_bar+1,j,i_r)+g_r_w(w_bar+2,j,i_r)*g_r(:,w_bar+2,j,i_r))...
            + k_m(j)*qr(i_r)*eligible(:,j).*sum(policy_prms_1(:,:,j,i_r).*(g_m_w(w_bar+1,j)*pw*g_m(:,:,w_bar+1,j) + g_m_w(w_bar+2,j)*g_m(:,:,w_bar+2,j)),2);
        end
        g_p(:,j) = g_mat(:,:,j)*g_p(:,j);

        a = max(sm,sum(g_p(:,j)));
        g_p(:,j) = g_p(:,j)/a;

        p_temp(j) = a;

         % g_r(y,0)-------------------------------------------------------------   

        for i_r=1:num_r

            g_r(:,1,j,i_r) = k_p(j)*qr(i_r)*policy_prm_2(:,1,j,i_r).*g_p(:,j)...
                         + k_r(j,i_r)*eligible(:,j).*policy_prm_2(:,2,j,i_r).*(g_r_w(w_bar+1,j,i_r)*pw*g_r(:,w_bar+1,j,i_r)+g_r_w(w_bar+2,j,i_r)*g_r(:,w_bar+2,j,i_r))...
                         + k_m(j)*qr(i_r)*eligible(:,j).*sum(policy_prms_2(:,:,j,i_r).*(g_m_w(w_bar+1,j)*pw*g_m(:,:,w_bar+1,j)+g_m_w(w_bar+2,j)*g_m(:,:,w_bar+2,j)),2);

            temp = zeros(num_y,1);    
            for i_w=1:w_bar+2
                temp = temp + k_r(j,i_r)*g_r_w(i_w,j,i_r)*policy_rm_2(:,2,1,j,i_r).*g_r_old(:,i_w,j,i_r)...
                            + k_m(j)*g_m_w(i_w,j)*qr(i_r)*sum(policy_rms_2(:,:,1,j,i_r).*g_m(:,:,i_w,j),2);
            end % i_w
            g_r(:,1,j,i_r) = g_r(:,1,j,i_r)+ ineligible(:,j).*temp;

            g_r(:,1,j,i_r) = g_mat(:,:,j)*g_r(:,1,j,i_r);

            a = max(sm,sum(g_r(:,1,j,i_r)));
            g_r(:,1,j,i_r) = g_r(:,1,j,i_r)/a;
            a = min(a, k_r(j,i_r));
            g_r_w(1,j,i_r) = a/max(sm,k_r(j,i_r));

            k_temp(j,i_r) = k_temp(j,i_r) + a;

        end


        % g_m(y,0) ------------------------------------------------------------

        % compute part not depend on h

        g_m_temp1 = k_p(j)*(1-sum(qr))*policy_pm_3(:,j).*g_p(:,j) ...
                  + k_m(j)*(1-sum(qr))*eligible(:,j).*sum(policy_pms_3(:,:,j).*(g_m_w(w_bar+1,j)*pw*g_m(:,:,w_bar+1,j)+g_m_w(w_bar+2,j)*g_m(:,:,w_bar+2,j)),2);

        for i_r=1:num_r
            g_m_temp1 = g_m_temp1 + ...
                  + k_p(j)*qr(i_r)*policy_prm_3(:,1,j,i_r).*g_p(:,j)...
                  + k_r(j,i_r)*eligible(:,j).*policy_prm_3(:,2,j,i_r).*(g_r_w(w_bar+1,j,i_r)*pw*g_r(:,w_bar+1,j,i_r)+g_r_w(w_bar+2,j,i_r)*g_r(:,w_bar+2,j,i_r))...
                  + k_m(j)*qr(i_r)*eligible(:,j).*sum(policy_prms_3(:,:,j,i_r).*(g_m_w(w_bar+1,j)*pw*g_m(:,:,w_bar+1,j)+g_m_w(w_bar+2,j)*g_m(:,:,w_bar+2,j)),2);
        end 

        g_m(:,:,1,j) =  repmat(g_m_temp1,1,num_y).*policy_h...
                    + k_m(j)*(1-sum(qr))*eligible_rep(:,:,j).*policy_pms_4(:,:,j).*(g_m_w(w_bar+1,j)*pw*g_m(:,:,w_bar+1,j)+g_m_w(w_bar+2,j)*g_m(:,:,w_bar+2,j));

        for i_r=1:num_r
            g_m(:,:,1,j) = g_m(:,:,1,j) ...
            + k_m(j)*qr(i_r)*eligible_rep(:,:,j).*policy_prms_4(:,:,j,i_r).*(g_m_w(w_bar+1,j)*pw*g_m(:,:,w_bar+1,j)+g_m_w(w_bar+2,j)*g_m(:,:,w_bar+2,j));
        end
        % compute part not depend on w   
        
        temp1 = (1-sum(qr))*policy_ms_3(:,:,1,j);

        for i_r=1:num_r
            temp1 = temp1 + qr(i_r)*policy_rms_3(:,:,1,j,i_r);
        end 
 
        temp2 = (1-sum(qr))*policy_ms_4(:,:,1,j);

        for i_r=1:num_r
            temp2 = temp2 + qr(i_r)*policy_rms_4(:,:,1,j,i_r);
        end 

        temp = zeros(num_y,num_y); 

        for i_w=1:w_bar+2
            
            g_m_temp2 = k_m(j)*g_m_w(i_w,j)*sum(temp1.*g_m_old(:,:,i_w,j),2) ;

            for i_r=1:num_r
                g_m_temp2 = g_m_temp2...
                    + k_r(j,i_r)*g_r_w(i_w,j,i_r)*policy_rm_3(:,2,1,j,i_r).*g_r(:,i_w,j,i_r);
            end
            
            temp = temp + repmat(g_m_temp2,1,num_y).*policy_h ...
                        + k_m(j)*g_m_w(i_w)*temp2.*g_m_old(:,:,i_w);
        end  % i_w

        g_m(:,:,1,j) = g_m(:,:,1,j) + ineligible_rep(:,:,j).*temp;

        g_m(:,:,1,j) = g_mat(:,:,j)*g_m(:,:,1,j);
        
        a = max(sm, sum(sum(g_m(:,:,1,j))));
        g_m(:,:,1,j) = g_m(:,:,1,j)/a;
        a = min(k_m(j),a);
        g_m_w(1,j) = a/max(sm,k_m(j));
        m_temp(j) = m_temp(j) + a;

        % w=1,2,...,w_bar+1 ---------------------------------------------------

       for  i_w=2:w_bar+2

           for i_r=1:num_r

               % g_r
                g_r(:,i_w,j,i_r) =  k_r(j,i_r)*g_r_w(i_w-1,j,i_r)*policy_rm_2(:,2,i_w,j,i_r).*g_r(:,i_w-1,j,i_r)...
                           +  k_m(j)*g_m_w(i_w-1,j)*qr(i_r)*sum(policy_rms_2(:,:,i_w,j,i_r).*g_m(:,:,i_w-1,j),2);

                g_r(:,i_w,j,i_r) = g_r(:,i_w,j,i_r).*eligible(:,j);  

%                 if j==1
%                     g_r(:,i_w,j,i_r) = g_mat_1*g_r(:,i_w,j,i_r);
%                 else
%                     g_r(:,i_w,j,i_r) = g_mat_2*g_r(:,i_w,j,i_r);
%                 end
                
                g_r(:,i_w,j,i_r) = g_mat(:,:,j)*g_r(:,i_w,j,i_r);

                a = max(sm,sum(g_r(:,i_w,j,i_r)));

                g_r(:,i_w,j,i_r) = g_r(:,i_w,j,i_r)/a;


                if i_w==w_bar+2
                    a = a*(1-pw);
                end

                g_r_w(i_w,j,i_r) = a/max(sm,k_r(j,i_r));
                k_temp(j,i_r) = k_temp(j,i_r)+a;


           end % i_r

           % g_m
           % compute part not depend on h
           
           temp3 = (1-sum(qr))*policy_ms_3(:,:,i_w,j);

           for i_r=1:num_r
               temp3 = temp3 + qr(i_r)*policy_rms_3(:,:,i_w,j,i_r);
           end 
           
           g_m_temp3 = k_m(j)*g_m_w(i_w-1,j)*sum(temp3.*g_m(:,:,i_w-1,j),2);

           for i_r = 1:num_r
               g_m_temp3    =  g_m_temp3 ...
                        +  k_r(j,i_r)*g_r_w(i_w-1,j,i_r)*policy_rm_3(:,2,i_w,j,i_r).*g_r(:,i_w-1,j,i_r);
           end

           g_m(:,:,i_w,j) = repmat(g_m_temp3,[1 num_y]).*policy_h ...
                       +  k_m(j)*g_m_w(i_w-1,j)*(1-sum(qr))*policy_ms_4(:,:,i_w,j).*g_m(:,:,i_w-1,j);
           for i_r = 1:num_r
               g_m(:,:,i_w,j) = g_m(:,:,i_w,j) ...
                   +  k_m(j)*g_m_w(i_w-1,j)*qr(i_r)*policy_rms_4(:,:,i_w,j,i_r).*g_m(:,:,i_w-1,j);
           end

           g_m(:,:,i_w,j) = g_m(:,:,i_w,j).*eligible_rep(:,:,j); 

           if j==1
                    g_m(:,:,i_w,j) = g_mat_1*g_m(:,:,i_w,j);               
            else
                    g_m(:,:,i_w,j) = g_mat_2*g_m(:,:,i_w,j);
            end

           a = max(sm,sum(sum(g_m(:,:,i_w,j))));

           g_m(:,:,i_w,j) = g_m(:,:,i_w,j)/a;

           g_m_w(i_w,j) = a/k_m(j);

           if i_w==w_bar+2
                g_m_w(i_w,j)= g_m_w(i_w,j)*(1-pw);
           end      

       end

        for i_r=1:num_r
            a = sum(g_r_w(1:w_bar+2,j,i_r));
            g_r_w(1:w_bar+2,j,i_r) = g_r_w(1:w_bar+2,j,i_r)/a;
        end

        a = sum(g_m_w(1:w_bar+2,j));
        g_m_w(:,j) = g_m_w(:,j)/a;


    end % j
    

    for j=1:n_type
    k_r(j,1) = k_rr(1)*k_temp(j,1)/max(sm,sum(k_temp(:,1)));
    k_r(j,1) = min(k_pmr(j)-sm,k_r(j,1));
    k_r(j,1) = max(sm,k_r(j,1));
    end
    
    for j=1:n_type
    k_r(j,2) = k_rr(2)*k_temp(j,2)/max(sm,sum(k_temp(:,2)));
    k_r(j,2) = min(k_pmr(j)-k_r(j,1)-sm,k_r(j,2));
    k_r(j,2) = max(sm,k_r(j,2));
    end
    
    for j=1:n_type
    k_m(j) = k_mm*m_temp(j)/max(sm,sum(m_temp));
    k_m(j) = min(k_pmr(j)-sum(k_r(j,:))-sm,k_m(j));
    k_m(j) = max(sm,k_m(j));
    end
    
    k_p = max(sm,k_pmr- k_m - sum(k_r,2)');

    % calculate distance
    for x = 1:n_type
    dist_v(1,x) = max(abs(g_p_old(:,x) - g_p(:,x)))./max(abs(g_p_old(:,x)));
    dist_v(2,x) = max(max(max(abs(g_m_old(:,:,1:w_bar+2,x) - g_m(:,:,1:w_bar+2,x)))))...
        ./max(max(max(abs(g_m_old(:,:,1:w_bar+2,x)))));
    dist_v(3,x) = max(max(max(abs(g_r_old(:,1:w_bar+2,x,:) - g_r(:,1:w_bar+2,x,:)))))...
        ./max(max(max(abs(g_r_old(:,1:w_bar+2,x,:)))));
    dist_v(4,x) = max(abs(g_m_w_old(1:w_bar+2,x) - g_m_w(1:w_bar+2,x)))...
        ./max(abs(g_m_w_old(1:w_bar+2,x)));
    dist_v(5,x) = max(max(abs(g_r_w_old(1:w_bar+2,x,:) - g_r_w(1:w_bar+2,x,:))))...
        ./max(max(abs(g_r_w_old(1:w_bar+2,x,:))));
    dist_v(6,x) = max(abs(k_r_old(x,:)-k_r(x,:)))./max(abs(k_r_old(x,:)));
    dist_v(7,x) = abs(k_p_old(x)-k_p(x))./abs(k_p_old(x));
    dist_v(8,x) = abs(k_m_old(x)-k_m(x))./abs(k_m_old(x));
    
    end
    dist = max(max(dist_v));   
  
    its = its +1;

end 

%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 4. Calcualte inflow and outflow
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% puclic housing
for j=1:n_type
    
    outflow(j) = sum(k_p(j)*(1-sum(qr))*policy_pm_3(:,j).*g_p(:,j));

    for i_r=1:num_r
        outflow(j) = outflow(j) + sum(k_p(j)*qr(i_r)*((policy_prm(:,1,j,i_r)> 1).*g_p(:,j)));       
    end      

    inflow(j) = sum(eligible(:,j).*(k_m(j)*(1-sum(qr))*sum(policy_pms_1(:,:,j).*(g_m_w(w_bar+1,j)*pw*g_m(:,:,w_bar+1,j)...
                                                                +g_m_w(w_bar+2,j)*g_m(:,:,w_bar+2,j)),2)));

    for i_r=1:num_r
        inflow(j) = inflow(j) + sum(eligible(:,j).*(k_m(j)*qr(i_r)*sum(policy_prms_1(:,:,j,i_r).*(g_m_w(w_bar+1,j)*pw*g_m(:,:,w_bar+1,j)+g_m_w(w_bar+2,j)*g_m(:,:,w_bar+2,j)),2)...
                        + k_r(j,i_r)*policy_prm_1(:,2,j,i_r).*(g_r_w(w_bar+1,j,i_r)*pw*g_r(:,w_bar+1,j,i_r) + g_r_w(w_bar+2,j,i_r)*g_r(:,w_bar+2,j,i_r))));
    end

    % regulated housing -------------------------------------------------------       
    

    for i_r=1:num_r
        % (1) with offer to public housing

        of_r(j,i_r) = sum(k_r(j,i_r)*eligible(:,j).*(policy_prm(:,2,j,i_r)~=2).*(pw*g_r_w(w_bar+1,j,i_r)*g_r(:,w_bar+1,j,i_r)...
                                                                        +g_r_w(w_bar+2,j,i_r)*g_r(:,w_bar+2,j,i_r)));

        if_r(j,i_r) = sum(k_p(j)*qr(i_r)*policy_prm_2(:,1,j,i_r).*g_p(:,j)...
                  + k_m(j)*qr(i_r)*eligible(:,j).*sum(policy_prms_2(:,:,j,i_r).*(pw*g_m_w(w_bar+1,j)*g_m(:,:,w_bar+1,j)+g_m_w(w_bar+2,j)*g_m(:,:,w_bar+2,j)),2));


        % (2) without the offer to the public housing
        for i_w=1:w_bar+1 % 0,...,w_bar

            if i_w==w_bar+1
                 px = pw;
            else
                 px = 0;
            end

             of_r(j,i_r) = of_r(j,i_r) +  (1-px)*k_r(j,i_r)*g_r_w(i_w,j,i_r)*sum(eligible(:,j).*policy_rm_3(:,2,i_w+1,j,i_r).*g_r(:,i_w,j,i_r));
             if_r(j,i_r) = if_r(j,i_r) +  (1-px)*k_m(j)*qr(i_r)*g_m_w(i_w,j)*sum(eligible(:,j).*sum(policy_rms_2(:,:,i_w+1,j,i_r).*g_m(:,:,i_w,j),2)); 

        end

         % (3) ineligible

        for i_w=1:w_bar+2 % 0,...,w_bar+1
                 of_r(j,i_r) = of_r(j,i_r) + k_r(j,i_r)*g_r_w(i_w,j,i_r)*sum(ineligible(:,j).*policy_rm_3(:,2,1,j,i_r).*g_r(:,i_w,j,i_r));
                 if_r(j,i_r) = if_r(j,i_r) + k_m(j)*qr(i_r)*g_m_w(i_w,j)*sum(ineligible(:,j).*sum(policy_rms_2(:,:,1,j,i_r).*g_m(:,:,i_w,j),2));
        end
    end
end

%--------------------------------------------------------------------------

    f(1) = sum(inflow) - sum(outflow);
    f(2:1+num_r) = sum(if_r,1) - sum(of_r,1);
 
