function [f,g_p,g_r,g_m,g_r_w,g_m_w,policy_pm,policy_prm,policy_pms,policy_prms,policy_rms,policy_ms,policy_rm,v_p,v_r,v_m] ...
    = flow_difference_baseline(x, sm, sm1, sm2, gamma,u_p,u_r,u_m,u_s,u_p_s,u_r_s,u_m_s,u_s_s,g_tran,g_tran_s,g_mat,y,y_s,h_m,h_m_s,k_p,k_r,k_m,num_y_s,num_y,max_w,y_low)
beta    = 0.95;      % discount factor
num_d = 3; % 1: public, 2: regulated, 3: market (mover + stayer);

% moving cost matrix
m_cost = gamma*ones(num_d,num_d);
for i=1:num_d
    m_cost(i,i) = 0;
end

% read input variables
x(1) = max(1,min(max_w,x(1)));        % restrict the w_bar be larger than 1 less than num_w
w_bar = floor(x(1));    
pw = 1-(x(1)-w_bar);
qr = x(2);
qr = min(1,max(0,qr));
num_w = w_bar+3;

% initialize arrays
% unconditional value functions
% coarse grids
v_r_s = zeros(num_y_s,num_w);
v_m_s = zeros(num_y_s,num_y_s,num_w);
% fine grids
v_r = zeros(num_y,num_w);
v_m = zeros(num_y,num_y,num_w);
% conditional value functions
% coarse grids
cv_p_s = zeros(num_y_s,num_d);
cv_m_s = zeros(num_y_s,num_w);
cv_s_s = zeros(num_y_s,num_y_s,num_w);
cv_r_s = zeros(num_y_s,num_d,num_w);
% fine grids
cv_p = zeros(num_y,num_d);
cv_m = zeros(num_y,num_w);
cv_s = zeros(num_y,num_y,num_w);
cv_r = zeros(num_y,num_d,num_w);
% densities
g_m_w = zeros(num_w,1);
g_m   = zeros(num_y,num_y,num_w);
g_r_w = zeros(num_w,1);
g_r   = zeros(num_y, num_w);
max_cv_r_m = zeros(num_y_s,num_d);
v_r_T = zeros(num_y_s,num_d);
%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 1. valufunction iteration
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% initial guess

u_max_s = max( max(u_p_s,u_m_s),u_r_s);

v_p_s = u_max_s/(1-beta);
for i_h = 1:num_y_s
    v_m_s(:,i_h,1) = u_max_s/(1-beta);
end
v_r_s(:,1) = u_max_s/(1-beta);

eligible = (y_s<=y_low);
ineligible = (y_s>y_low);
eligible_rep = repmat(eligible,1,num_y_s);
ineligible_rep = repmat(ineligible,1,num_y_s);

dist =1; % error
its  =0; % interation
dist_temp = zeros(3,1);
f = zeros(2,1);
while (dist > sm1) && (its < 200)
    
    v_m_old = v_m_s(:,:,1);
    v_p_old = v_p_s;
    v_r_old = v_r_s(:,1);
    
    % conditional value function : public housing (d=1)
    for i_d=1:num_d
        cv_p_s(:,i_d) = u_p_s - m_cost(1,i_d) + beta*g_tran_s*v_p_s;
    end
    
    % conditional value function : regulated (d=2)
    for i_d= 1:num_d
        cv_r_s(:,i_d,1)=u_r_s-m_cost(2,i_d)+beta*g_tran_s*v_r_s(:,1);
    end
    
    % conditional value function : mover (d=3)
    for i_y=1:num_y_s
    cv_m_s(i_y,1)=u_m_s(i_y)-gamma+beta*g_tran_s(i_y,:)*v_m_s(:,i_y,1);
    end
    
    % conditional value function : stayer (d=4)
    cv_s_s(:,:,1)=u_s_s+beta*g_tran_s*v_m_s(:,:,1);
         
    for i_d=1:num_d
        max_cv_r_m(:,i_d) = max(cv_m_s(:,1),cv_r_s(:,i_d,1));
        v_r_T(:,i_d) =max(cv_p_s(:,i_d),max_cv_r_m(:,i_d));
    end
    
    v_p_s   = (1-qr)*max(cv_p_s(:,1),cv_m_s(:,1))+ qr*v_r_T(:,1);
      
    % update conditional value function : public housing (d=1)
    for i_d=1:num_d
        cv_p_s(:,i_d) = u_p_s - m_cost(1,i_d) + beta*g_tran_s*v_p_s;
    end
    
    for i_d=1:num_d
        %max_cv_r_m(:,i_d) = max(cv_m_s(:,1),cv_r_s(:,i_d,1));
        v_r_T(:,i_d) =max(cv_p_s(:,i_d),max_cv_r_m(:,i_d));
    end
    
    % backward induction
    
    max_cv_m_s = max(repmat(cv_m_s(:,1),1,num_y_s),cv_s_s(:,:,1));
   
    max_cv_r_m_s = max(max_cv_m_s,repmat(cv_r_s(:,3,1),1,num_y_s));
    
    for i_w=w_bar+2:-1:1
        
        if i_w < w_bar+2
       
            % conditional value function : regulated (d=2)
            for i_d= 1:num_d
                cv_r_s(:,i_d,i_w+1)=u_r_s-m_cost(2,i_d)+beta*g_tran_s*v_r_s(:,i_w+1);
            end

            % conditional value function : mover (d=3)
            temp = g_tran_s*v_m_s(:,:,i_w+1);        
            cv_m_s(:,i_w+1)=u_m_s-gamma+beta*diag(temp);

            % conditional value function : stayer (d=4)
            cv_s_s(:,:,i_w+1)=u_s_s+beta*temp;
        
        end
              
         
        if i_w<w_bar+1
             v_r_s(:,i_w) =  eligible.*max(cv_m_s(:,i_w+1), cv_r_s(:,2,i_w+1)) + ineligible.*max_cv_r_m(:,2);     

              temp = max(repmat(cv_m_s(:,i_w+1),1,num_y_s),cv_s_s(:,:,i_w+1));
              v_m_s(:,:,i_w) = eligible_rep.*(qr*max(temp,repmat(cv_r_s(:,3,i_w+1),1,num_y_s)) + (1-qr)*temp )...
                               + ineligible_rep.*(qr*max_cv_r_m_s+ (1-qr)*max_cv_m_s); 
            
            
        elseif i_w==w_bar+1
            v_r_s(:,i_w) = pw*eligible.*v_r_T(:,2)...
                       + (1-pw)*eligible.*max(cv_m_s(:,i_w+1), cv_r_s(:,2,i_w+1))...
                       + ineligible.*max_cv_r_m(:,2);
                   
             
             temp = max(repmat(cv_m_s(:,i_w+1),1,num_y_s),cv_s_s(:,:,i_w+1));
             v_m_s(:,:,i_w) =  eligible_rep.*(qr*pw*max(repmat(v_r_T(:,3),1,num_y_s),cv_s_s(:,:,1))...
                        + qr*(1-pw)*max(temp,repmat(cv_r_s(:,3,i_w+1),1,num_y_s))...
                        + (1-qr)*pw*max(repmat(max(cv_m_s(:,1), cv_p_s(:,3)),1,num_y_s),cv_s_s(:,:,1))...
                        + (1-qr)*(1-pw)*temp )...
                        + ineligible_rep.*(qr*max_cv_r_m_s(:,:)...
                        + (1-qr)*max_cv_m_s(:,:));           
           
        else % i_w=w_bar+2
                     
            v_r_s(:,i_w) = eligible.*v_r_T(:,2)...
                       + ineligible.*max_cv_r_m(:,2);                  
                        
            
             v_m_s(:,:,i_w) =  eligible_rep.*(qr*max(repmat(v_r_T(:,3),1,num_y_s),cv_s_s(:,:,1))...
                        + (1-qr)*max(repmat(max(cv_m_s(:,1), cv_p_s(:,3)),1,num_y_s),cv_s_s(:,:,1)))...
                        + ineligible_rep.*(qr*max_cv_r_m_s(:,:)...
                        + (1-qr)*max_cv_m_s(:,:)); 
        end        
    end 
      
    % convergence criterion
    dist_temp(1) = max(abs(v_p_s-v_p_old))/max(abs(v_p_old));
    dist_temp(2) = max(max(abs(v_m_s(:,:,1) - v_m_old)))/max(max(abs(v_m_old)));
    dist_temp(3) = max(abs(v_r_s(:,1) - v_r_old))/max(abs(v_r_old));
    dist = max(dist_temp);
    
    its = its+1;
   
end

%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2. Policy function
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%interpolation using fine grids
v_p = interp1(y_s,v_p_s,y);

[y_s_mesh, h_s_mesh] = meshgrid(y_s, h_m_s);
[y_mesh, h_mesh] = meshgrid(y, h_m);
for j=1:w_bar+2
    v_m(:,:,j) = interp2(y_s_mesh,h_s_mesh, v_m_s(:,:,j),y_mesh,h_mesh);
    v_r(:,j) = interp1(y_s, v_r_s(:,j),y);
end

% conditional value function : public housing (d=1)
for i_d=1:num_d
    cv_p(:,i_d) = u_p - m_cost(1,i_d) + beta*g_tran*v_p;
end


% conditional value function : regulated (d=2)
for i_w=1:w_bar+2
    for i_d= 1:num_d
        cv_r(:,i_d,i_w)=u_r - m_cost(2,i_d)+beta*g_tran*v_r(:,i_w);
    end % i

    % conditional value function : mover (d=3)
    for i_y=1:num_y
    cv_m(i_y,i_w)=u_m(i_y)-gamma+beta*g_tran(i_y,:)*v_m(:,i_y,i_w);
    end % i_y

    % conditional value function : stayer (d=4)
    cv_s(:,:,i_w)=u_s+beta*g_tran*v_m(:,:,i_w);
end % i_w

% choice between public(1) and move(3,w=0), d=1 by construction
policy_pm =  1 + 2*(cv_m(:,1)> cv_p(:,1));

% choice among public(1), regulated(2,w=0), move(3,w=0), d=1 or 2
policy_prm = zeros(num_y,num_d);
for i_d=1:num_d
    policy_prm(:,i_d) = 1+ 1*(cv_r(:,i_d,1) > cv_p(:,i_d)).*(cv_r(:,i_d,1) >= cv_m(:,1))...
                         + 2*(cv_m(:,1) > cv_p(:,i_d)).*(cv_m(:,1) > cv_r(:,i_d,1));
end % i_d

% choice among public(1), move(3,w=0), stay(4,w=0), d=3 by construction
policy_pms = zeros(num_y,num_y);
for i_h=1:num_y
    policy_pms(:,i_h) = 1 +2*(cv_m(:,1) > cv_p(:,3)).*(cv_m(:,1)>=cv_s(:,i_h,1))...
                          +3*(cv_s(:,i_h,1) > cv_p(:,3)).*(cv_s(:,i_h,1)>cv_m(:,1));
end

% choice among public(1), regulated(2,w=0), move(3,w=0), stay(4,w=0), d=3 by
% construction
policy_prms = zeros(num_y,num_y);
for i_h=1:num_y
    policy_prms(:,i_h) = 1+1*(cv_r(:,3,1) > cv_p(:,3)).*(cv_r(:,3,1) >= cv_m(:,1)).*(cv_r(:,3,1)>=cv_s(:,i_h,1))...
                        +2*(cv_m(:,1) > cv_p(:,3)).*(cv_m(:,1) > cv_r(:,3,1)).*(cv_m(:,1)>=cv_s(:,i_h,1))...
                        +3*(cv_s(:,i_h,1) > cv_p(:,3)).*(cv_s(:,i_h,1)> cv_r(:,3,1)).*(cv_s(:,i_h,1)>cv_m(:,1));
end

% choice regulated(2,w=0), move(3), stay(4), d=3 by
% construction
policy_rms = zeros(num_y,num_y,w_bar+2);
for i_w=1:w_bar+2
    for i_h=1:num_y
        policy_rms(:,i_h,i_w) = 2+1*(cv_m(:,i_w) > cv_r(:,3,i_w)).*(cv_m(:,i_w)>=cv_s(:,i_h,i_w))...
                                 +2*(cv_s(:,i_h,i_w)> cv_r(:,3,i_w)).*(cv_s(:,i_h,i_w)>cv_m(:,i_w));
    end
end

policy_h = eye(num_y);

% choice among move(3), stay(4), d=3 by construction
policy_ms = zeros(num_y,num_y,w_bar+2);
for i_w= 1:w_bar+2
    for i_h=1:num_y
        policy_ms(:,i_h,i_w) = 3 + 1*(cv_s(:,i_h,i_w)>cv_m(:,i_w));
    end
end

% choice between, regulated(2) and market(3)
policy_rm = zeros(num_y,num_d,w_bar+2);
for i_d = 1:num_d
    for i_w=1:w_bar+2
        policy_rm(:,i_d,i_w) = 2 + 1*(cv_m(:,i_w) > cv_r(:,i_d,i_w));
    end
end

policy_pm_1 = (policy_pm == 1);
policy_pm_3 = (policy_pm == 3);

policy_prm_1 = (policy_prm == 1);
policy_prm_2 = (policy_prm == 2);
policy_prm_3 = (policy_prm == 3);

policy_pms_1 = (policy_pms == 1);
policy_pms_3 = (policy_pms == 3);
policy_pms_4 = (policy_pms == 4);

policy_prms_1 = (policy_prms == 1);
policy_prms_2 = (policy_prms == 2);
policy_prms_3 = (policy_prms == 3);
policy_prms_4 = (policy_prms == 4);

policy_rms_2 = (policy_rms == 2);
policy_rms_3 = (policy_rms == 3);
policy_rms_4 = (policy_rms == 4);

policy_ms_3 = (policy_ms == 3);
policy_ms_4 = (policy_ms == 4);

policy_rm_2 = (policy_rm == 2);
policy_rm_3 = (policy_rm == 3);

%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3. Calculte SS densities by forward interation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% initial guess
g_p = mean(g_mat,2);

for i_w=1:w_bar+2
    for ih=1:num_y
        g_m(:,ih,i_w)   = mean(g_mat,2)/double(num_y);
    end
    g_r(:,i_w)   = mean(g_mat,2);
end

g_w = 1/(1+w_bar + 1 -pw);
g_r_w(1:w_bar+1) = g_w;
g_r_w(w_bar+2)   = g_w*(1-pw);
g_m_w(1:w_bar+1) = g_w;
g_m_w(w_bar+2)   = g_w*(1-pw);

eligible = (y<=y_low);
ineligible = (y>y_low);
eligible_rep = repmat(eligible,1,num_y);
ineligible_rep = repmat(ineligible,1,num_y);

dist = 1.0;
its = 0;
dist_v = zeros(5,1);
% start iteration
while dist > sm2 && its<500  
    
    % save starting value        
    g_p_old = g_p;
    g_m_old = g_m;
    g_r_old = g_r;
    g_m_w_old = g_m_w;
    g_r_w_old = g_r_w;
    
    % g_p ----------------------------------------------------------------       
              
    g_p = (k_p*(1-qr)*(policy_pm_1.*g_p + k_p*qr*policy_prm_1(:,1).*g_p)) ... 
        + eligible.*policy_prm_1(:,2).*(k_r*g_r_w(w_bar+1)*pw*g_r(:,w_bar+1)+k_r*g_r_w(w_bar+2)*g_r(:,w_bar+2))...
        + k_m*(1-qr)*eligible.*sum(policy_pms_1.*(g_m_w(w_bar+1)*pw*g_m(:,:,w_bar+1) + g_m_w(w_bar+2)*g_m(:,:,w_bar+2)),2) ...
        + k_m*qr*eligible.*sum(policy_prms_1.*(g_m_w(w_bar+1)*pw*g_m(:,:,w_bar+1) + g_m_w(w_bar+2)*g_m(:,:,w_bar+2)),2);
       
    g_p = g_mat*g_p;

    a = max(sm,sum(g_p));
    g_p = g_p/a;
    
     % g_r(y,0)-------------------------------------------------------------   
          
    g_r(:,1) = k_p*qr*policy_prm_2(:,1).*g_p...
             + k_r*eligible.*policy_prm_2(:,2).*(g_r_w(w_bar+1)*pw*g_r(:,w_bar+1)+g_r_w(w_bar+2)*g_r(:,w_bar+2))...
             + k_m*qr*eligible.*sum(policy_prms_2.*(g_m_w(w_bar+1)*pw*g_m(:,:,w_bar+1)+g_m_w(w_bar+2)*g_m(:,:,w_bar+2)),2);
    
    temp = zeros(num_y,1);    
    for i_w=1:w_bar+2
        temp = temp + k_r*g_r_w(i_w)*policy_rm_2(:,2,1).*g_r_old(:,i_w)...
                    + k_m*g_m_w(i_w)*qr*sum(policy_rms_2(:,:,1).*g_m(:,:,i_w),2);
    end % i_w
    g_r(:,1) = g_r(:,1)+ ineligible.*temp;
    
    g_r(:,1) = g_mat*g_r(:,1);

    a = max(sm,sum(g_r(:,1)));
    g_r(:,1) = g_r(:,1)/a;
    
    g_r_w(1) = a/k_r;
    
                   
    % g_m(y,0) ------------------------------------------------------------
    % compute part not depend on h         
    g_m_temp1 = k_p*(1-qr)*policy_pm_3.*g_p ...
              + k_p*qr*policy_prm_3(:,1).*g_p...
              + k_r*eligible.*policy_prm_3(:,2).*(g_r_w(w_bar+1)*pw*g_r(:,w_bar+1)+g_r_w(w_bar+2)*g_r(:,w_bar+2))...
              + k_m*eligible.*sum(((1-qr)*policy_pms_3+qr*policy_prms_3).*(g_m_w(w_bar+1)*pw*g_m(:,:,w_bar+1)+g_m_w(w_bar+2)*g_m(:,:,w_bar+2)),2);
      
    
    g_m(:,:,1) =  repmat(g_m_temp1,1,num_y).*policy_h...
                + k_m*eligible_rep.*((1-qr)*policy_pms_4+qr*policy_prms_4)...
                .*(g_m_w(w_bar+1)*pw*g_m(:,:,w_bar+1)+g_m_w(w_bar+2)*g_m(:,:,w_bar+2));
            
    % ineligible case
    temp = zeros(num_y,num_y);   
    temp1 = (1-qr)*policy_ms_3(:,:,1) + qr*policy_rms_3(:,:,1);
    temp2 = (1-qr)*policy_ms_4(:,:,1) + qr*policy_rms_4(:,:,1);
    for i_w=1:w_bar+2
        g_m_temp2 = k_r*g_r_w(i_w)*policy_rm_3(:,2,1).*g_r(:,i_w)...
                  + k_m*g_m_w(i_w)*sum(temp1.*g_m_old(:,:,i_w),2);
        temp = temp + repmat(g_m_temp2,1,num_y).*policy_h ...
                    + k_m*g_m_w(i_w)*temp2.*g_m_old(:,:,i_w);
    end  % i_w

    g_m(:,:,1) = g_m(:,:,1) + ineligible_rep.*temp;

    g_m(:,:,1) = g_mat*g_m(:,:,1);   

   
    a = max(sm, sum(sum(g_m(:,:,1))));
    g_m(:,:,1) = g_m(:,:,1)/a;
    g_m_w(1) = a/k_m;
    
    % w=1,2,...,w_bar+1 ---------------------------------------------------
   
   for  i_w=2:w_bar+2
       
       % g_r
        g_r(:,i_w) =  k_r*g_r_w(i_w-1)*policy_rm_2(:,2,i_w).*g_r(:,i_w-1)...
                   +  k_m*g_m_w(i_w-1)*qr*sum(policy_rms_2(:,:,i_w).*g_m(:,:,i_w-1),2);

        g_r(:,i_w) = g_r(:,i_w).*eligible;  

        g_r(:,i_w) = g_mat*g_r(:,i_w);

        a = max(sm,sum(g_r(:,i_w)));
        g_r(:,i_w) = g_r(:,i_w)/a;

        g_r_w(i_w) = a/k_r;

        if i_w==w_bar+2
            g_r_w(i_w)= g_r_w(i_w)*(1-pw);
        end

       % g_m
       % compute part not depend on h
       g_m_temp3    =  k_r*g_r_w(i_w-1)*policy_rm_3(:,2,i_w).*g_r(:,i_w-1)...
                    +  k_m*g_m_w(i_w-1)*sum(((1-qr)*policy_ms_3(:,:,i_w)+qr*policy_rms_3(:,:,i_w)).*g_m(:,:,i_w-1),2);

       g_m(:,:,i_w) = repmat(g_m_temp3,[1 num_y]).*policy_h ...
                   +  k_m*g_m_w(i_w-1)*((1-qr)*policy_ms_4(:,:,i_w) + qr*policy_rms_4(:,:,i_w)).*g_m(:,:,i_w-1);


       g_m(:,:,i_w) = g_m(:,:,i_w).*eligible_rep; 

       g_m(:,:,i_w) = g_mat*g_m(:,:,i_w);

       a = max(sm,sum(sum(g_m(:,:,i_w))));
       
       g_m(:,:,i_w) = g_m(:,:,i_w)/a;

       g_m_w(i_w) = a/k_m;

       if i_w==w_bar+2
            g_m_w(i_w)= g_m_w(i_w)*(1-pw);
       end      
    
   end

    a = sum(g_r_w(1:w_bar+2));
    g_r_w = g_r_w/a;
    
    a = sum(g_m_w(1:w_bar+2));
    g_m_w = g_m_w/a;
    
    % distance and update     

    dist_v(1) = max(abs(g_p_old - g_p))/max(abs(g_p_old ));
    dist_v(2) = max(max(max(abs(g_m_old(:,:,1:w_bar+2) - g_m(:,:,1:w_bar+2)))))/max(max(max(abs(g_m_old(:,:,1:w_bar+2)))));
    dist_v(3) = max(max(abs(g_r_old(:,1:w_bar+2) - g_r(:,1:w_bar+2))))/max(max(abs(g_r_old(:,1:w_bar+2))));
    dist_v(4) = max(abs(g_m_w_old(1:w_bar+2) - g_m_w(1:w_bar+2)))/max(abs(g_m_w_old(1:w_bar+2)));
    dist_v(5) = max(abs(g_r_w_old(1:w_bar+2) - g_r_w(1:w_bar+2)))/max(abs(g_r_w_old(1:w_bar+2))); 
   
    dist = max(dist_v);       
  
    its = its +1;
    %disp(dist)
end 
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 4. Calcualte inflow and outflow
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% puclic housing
outflow =   sum(k_p*((1-qr)*policy_pm_3 + qr*(policy_prm(:,1)>1)).*g_p);
       
inflow =    sum(eligible.*(k_m*(1-qr)*sum(policy_pms_1.*(g_m_w(w_bar+1)*pw*g_m(:,:,w_bar+1)+g_m_w(w_bar+2)*g_m(:,:,w_bar+2)),2)...
                         + k_m*qr*sum(policy_prms_1.*(g_m_w(w_bar+1)*pw*g_m(:,:,w_bar+1)+g_m_w(w_bar+2)*g_m(:,:,w_bar+2)),2)...
                         + k_r*policy_prm_1(:,2).*(g_r_w(w_bar+1)*pw*g_r(:,w_bar+1) + g_r_w(w_bar+2)*g_r(:,w_bar+2))));
        
% regulated housing -------------------------------------------------------       

% (1) with offer to public housing

of_r = sum(k_r*eligible.*(policy_prm(:,2)~=2).*(pw*g_r_w(w_bar+1)*g_r(:,w_bar+1)+g_r_w(w_bar+2)*g_r(:,w_bar+2)));

if_r = sum(k_p*qr*policy_prm_2(:,1).*g_p...
          +k_m*qr*eligible.*sum(policy_prms_2.*(pw*g_m_w(w_bar+1)*g_m(:,:,w_bar+1)+g_m_w(w_bar+2)*g_m(:,:,w_bar+2)),2));
   
   
% (2) without the offer to the public housing
for i_w=1:w_bar+1 % 0,...,w_bar
     
    if i_w==w_bar+1
         px = pw;
    else
         px = 0;
    end
     
     of_r = of_r +  (1-px)*k_r*g_r_w(i_w)*sum(eligible.*policy_rm_3(:,2,i_w+1).*g_r(:,i_w));
     if_r = if_r +  (1-px)*k_m*qr*g_m_w(i_w)*sum(eligible.*sum(policy_rms_2(:,:,i_w+1).*g_m(:,:,i_w),2)); 

end
 
 % (3) ineligible
 
for i_w=1:w_bar+2 % 0,...,w_bar+1
         of_r = of_r + k_r*g_r_w(i_w)*sum(ineligible.*policy_rm_3(:,2,1).*g_r(:,i_w));
         if_r = if_r + k_m*qr*g_m_w(i_w)*sum(ineligible.*sum(policy_rms_2(:,:,1).*g_m(:,:,i_w),2));
end
 
%--------------------------------------------------------------------------

    f(1,1) = inflow - outflow;
    f(2,1) = if_r - of_r;


